UMaps = {}
UMaps.nextmap = ""
UMaps.lastX = 0
UMaps.showtimer = false
UMaps.timeleft = nil
UMaps.msg = nil
surface.CreateFont( "Arial", ( ScrH() / 24 ), 500, false, false, "UMapsAlert" )

function UMaps.formatTime( s )
	local m = math.floor( s / 60 )
	s = math.fmod( s, 60 )
	local h = math.floor( m / 60 )
	m = math.fmod( m, 60 )
	local str = ""
	if h > 0 then str = tostring( h ) .. "hours " end
	if m > 0 then str = str .. tostring( m ) .. "min " end
	str = str .. tostring( s ) .. "sec"
	return str
end

function UMaps.Paint()
	if UMaps.msg then
		draw.SimpleText( UMaps.msg, "UMapsAlert", ( ScrW() / 2 ), ( ScrH() / 2 ), Color( 255, 255, 255, 255 ), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER )
	end
	if not UMaps.showtimer then return end
	draw.RoundedBox( 8, ( ScrW() / 2 ) - ( ScrW() / 8 ), ( ScrH() / 4 ), ( ScrW() / 4 ), ( ScrH() / 8 ), Color( 255, 50, 50, 200 ) )
	draw.SimpleText( "Changing map to", "UMapsAlert", ( ScrW() / 2 ), ( ScrH() / 4 ), Color( 255, 255, 255, 200), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP )
	draw.SimpleText( UMaps.nextmap, "UMapsAlert", ( ScrW() / 2 ), ( ScrH() / 4 ) + ( ScrH() / 24 ), Color( 255, 255, 255, 200), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP )
	draw.SimpleText( UMaps.formatTime( UMaps.timeleft ), "UMapsAlert", ( ScrW() / 2 ), ( ScrH() / 4 ) + ( ScrH() / 12 ), Color( 255, 255, 255, 200), TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP )
end
hook.Add( "HUDPaint", "UMaps.Paint", UMaps.Paint )

function UMaps.recieveTimer( um )
	UMaps.nextmap = um:ReadString()
	UMaps.timeleft = math.floor( um:ReadLong() )
	if um:ReadBool() then
		UMaps.showMsg( "Use umaps_hide to hide the alert." )
		UMaps.showtimer = true
	end
	if not timer.IsTimer( "UMaps_Count" ) then
		timer.Create( "UMaps_Count", 1, 0, function() UMaps.timeleft = UMaps.timeleft - 1 end )
	end
end
usermessage.Hook( "UMaps_timer", UMaps.recieveTimer )

function UMaps.showMsg( msg )
	UMaps.msg = msg
	timer.Create( "UMaps_message", 10, 1, function() UMaps.msg = nil end )
end

concommand.Add( "umaps_hide", function( ply, cmd, args ) UMaps.showtimer = false UMaps.showMsg( "UMap alert hidden. Use umaps_show to bring it back." ) end )
concommand.Add( "umaps_show", function( ply, cmd, args ) UMaps.showtimer = true UMaps.showMsg( "Use umaps_hide to hide the alert." ) end )
concommand.Add( "umaps_timeleft", function( ply ) UMaps.showMsg( "Time left: " .. UMaps.formatTime( tostring( UMaps.timeleft ) ) ) end )
concommand.Add( "umaps_nextmap", function( ply ) UMaps.showMsg( "Next map: " .. UMaps.nextmap ) end )